/*
==============================================================================

	MIMPI to SRYRpC

==============================================================================
                                                 Copyright(C)1998 T.Ohtake
                                                 All rights reserved.
==============================================================================

NXꗗ


* End of class list
==============================================================================
$Header:

$Log: $
==============================================================================
*/

#include <cstring.h>
#include <fstream.h>
#include <jctype.h>
#include <stdio.h>
#include <process.h>
#include "ver.h"

#include "secl.h"

//#define IMPBUG

int main(int argc, char **argv)
{
	printf("\n"
	       COMPILER_NAME"\n" //"Sherry easy compiler version 1.1\n"
	       "copyright(c) 1997,1998 ӂ݂. All rights reserved.\n");

	if (argc == 1)
	{
		printf("\nusage: secl <source filename *.ESR> "
		       "[[<output filename *.SRY>] <smf filename *.MID>] [/D]\n\n/D : Add debug information\n");
		return 0;
	}

	string outfile;
	string infile;
	string smffile;

	string param[3];
	bool debug = false;
	int params = 0;

	for(int i = 1; i < argc; i++)
	{
		const char *p = argv[i];

		if (p[0] == '/')
		{
			// IvV
			if (toupper(p[1]) == 'D')
			{
				debug = true;
			}
		}
		else if (params < 3)
		{
			param[params++] = p;
		}
		else
		{
			printf("\np[^܂B");
			return 1;
		}
	}

	if (params == 0)
	{
		printf("\nt@Cw肵ĉB\n");
		return 1;
	}
	if (params >= 1)
		infile = param[0];
	if (params >= 2)
		outfile = param[1];
	if (params >= 3)
		smffile = param[2];

	infile = AddExt(infile.c_str(), "esr");

	if (smffile.is_null())
		smffile = AddExt(infile.c_str(), "mid");

	if (outfile.is_null())
		outfile = AddExt(infile.c_str(), "sry");

	int err;
	try
	{
		Compiler comp(infile.c_str(), outfile.c_str(), smffile.c_str(), debug);

		printf("\nCompiling %s...", outfile.c_str());
		err = comp.Execute();
	}
	catch (Error *e)
	{
		printf("\n%s", e->msg.c_str());
		err++;
		delete e;
	}

	return err ? 1 : 0;
}

