
#ifndef __S_PALETTE_H_
#define __S_PALETTE_H_

#include "wrdsub.h"

// ==================================================================
//  pbg
// ==================================================================
struct SPalette
{
	SByte red;
	SByte green;
	SByte blue;

	SPalette() {red = green = blue = 0;}
};

class SPalettes
{
	public:
	SPalette palettes[256];

	SPalettes(SPalette *, int n);
	SPalettes();

//	void Merge(const SPalettes &i1, const SPalettes &i2,
//	           ....);

	void MaskCopy(const SPalettes &o, char mask[]);
	void Set(int index, int r, int g, int b)
	    { palettes[index].red = r;
	      palettes[index].green = g;
	      palettes[index].blue = b;
	    }
	SPalette &operator[](int index) {return palettes[index];}
};

#endif
